package db.cm;

import java.sql.Connection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import db.conn.ConnectorFactory;

public class ConnectionManager {
	
	private static ConnectionManager mCM=new ConnectionManager();
	private Map mConnectorFactories=null;
	private String mDefName=null;
	
	public void destroy(){
		String mName=null;
		ConnectorFactory mCF=null;
		if(mConnectorFactories!=null){
			Iterator mIterator = null;
			mIterator=mConnectorFactories.keySet().iterator();
			while(mIterator.hasNext()) {
				mName=(String)mIterator.next();
				mCF=(ConnectorFactory) mConnectorFactories.get(mName);
				if(mCF!=null) {
					mCF.destroy();
					mConnectorFactories.remove(mName);
				}
			}
		}
		mCF=null;
		mConnectorFactories=null;
		mDefName=null;
	}
	
	public void init(){
		destroy();
		mConnectorFactories=new HashMap();
	}

	private ConnectionManager(){
		init();
	}
		
	public static ConnectionManager getInstance(){
		return mCM;
	}
	
	public Connection getConnection(String pName) {
		ConnectorFactory mCF=null;
		Connection mCon=null;
		if(pName!=null)
			mCF=(ConnectorFactory) mConnectorFactories.get(pName);
		if(mCF!=null) mCon=mCF.getConnection();
		mCF=null;		
		return mCon;
	}
	
	private String getDefaultConnectionName(){
		return mDefName;
	}

	public void setDefaultConnectionName(String pDefName){
		if(pDefName!=null&&mConnectorFactories.get(pDefName)!=null)
			mDefName=pDefName;
	}

	public Connection getDefaultConnection() {
		return getConnection(getDefaultConnectionName());
	}
	
	public void addConnectorFactory(String pName, ConnectorFactory pCF){
		if(pName!=null&&!("".equals(pName))&&pCF!=null)
		mConnectorFactories.put(pName,pCF);
	}
	
	protected void finalize() throws Throwable {
		destroy();
	}
	
}