package db.conn.impl;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.Properties;
import db.conn.AbstractConnectorFactory;
import db.util.Instantiator;

public class JDBCConnectorFactory extends AbstractConnectorFactory {
	
	private String mDriver=null;
	private String mJDBCUrl=null;
	private Properties mProp=null;
	
	public void initializeValues(Properties pProp) {
		if(pProp!=null){
			mProp=pProp;
			mDriver=mProp.getProperty("driverClassName");
			mJDBCUrl=mProp.getProperty("url");
		}
	}
	
	public void destroy() {
		mDriver=null;
		mJDBCUrl=null;
		mProp=null;
	}
	
	public Connection getConnection() {
		Connection mCon=null;
		if(mDriver==null) mCon=super.getConnection();
		else {
			if(Instantiator.getInstance().createObject(mDriver)!=null) {
				try {
					mCon=DriverManager.getConnection(mJDBCUrl,mProp);					
				} catch (SQLException eSQLE) {
					eSQLE.printStackTrace();
					mCon=null;
				}						
			}				
		}		
		return mCon;
	}
	
	public String toString() {		
		if(mProp!=null)
			return getClass()+": "+mProp.toString();
		return getClass()+": No Properties";
	}

}