package db.cw;

import java.io.File;
import java.sql.Connection;
import java.sql.SQLException;
import db.cm.ConnectionManager;
import db.cm.config.Configurator;
import db.cm.config.impl.PropertyConfigurator;
import db.cm.config.impl.ResourceBundleConfigurator;
import db.cm.config.impl.XMLConfigurator;

public class ConnectionWrapper{
	
	private static ConnectionWrapper mCW=new ConnectionWrapper();	
	private boolean mInited=false;
	private String mPath=null;

	private void initCM(boolean pReconf){
		 Configurator mConf=null;
		 Connection mCon=null;
		 
		 mInited=false;
		 
		 if(mCon==null) { 
			if(mPath==null) mConf=new ResourceBundleConfigurator();
		 	else mConf=new ResourceBundleConfigurator(mPath+"."+"dbcm");
		 	if(pReconf) mConf.reconfigure(ConnectionManager.getInstance());
		 	else mConf.configure(ConnectionManager.getInstance()); 
		 	if((mCon=ConnectionManager.getInstance().getDefaultConnection())!=null) mInited=true;
		 }
		 
		 if(mCon==null) {
			 if(mPath==null) mConf=new PropertyConfigurator();
			 else mConf=new PropertyConfigurator(mPath+File.separator+"db.cm.properties");
			 if(pReconf) mConf.reconfigure(ConnectionManager.getInstance());
			 else mConf.configure(ConnectionManager.getInstance());
			 if((mCon=ConnectionManager.getInstance().getDefaultConnection())!=null) mInited=true;
		 }

		 if(mCon==null) {			 
			if(mPath==null) mConf=new XMLConfigurator();
			else mConf=new XMLConfigurator(mPath+File.separator+"db.cm.xml");
			if(pReconf) mConf.reconfigure(ConnectionManager.getInstance());
			else mConf.configure(ConnectionManager.getInstance());
		 	if((mCon=ConnectionManager.getInstance().getDefaultConnection())!=null) mInited=true;
		 }
		 
		 if(mCon!=null) {
			 instCloseConnection(mCon);
			 mCon=null;
		 }	 
	}

	private ConnectionWrapper(){
			initCM(false);
	}
	
	private static ConnectionWrapper getInstance(){
		return mCW;
	}
	
	private void instSetDirectoryPath(String pPath){
		if(pPath!=null&&!("".equals(pPath)))
			mPath=pPath;
	}
	
	private Connection instGetConnection(){
		if(!mInited) initCM(false);	
		ConnectionManager mCM=ConnectionManager.getInstance();
		return mCM.getDefaultConnection();
	}
	
	private Connection instGetConnection(String pName){
		if(!mInited) initCM(false);	
		ConnectionManager mCM=ConnectionManager.getInstance();
		return mCM.getConnection(pName);
	}
	
	private void instCloseConnection(Connection pCon){
		if(pCon!=null) {
			try {
				pCon.close();
			} catch (SQLException eSQLE) {
				eSQLE.printStackTrace();		
			}
		}
	}
	
	private void instReconfigure(){
		initCM(true);
	}	
	
	public static void setDirectoryPath(String pPath){
		getInstance().instSetDirectoryPath(pPath);
	}
	
	public static Connection getConnection(){
		return getInstance().instGetConnection();
	}
	
	public static Connection getConnection(String pName){
		return getInstance().instGetConnection(pName);
	}
	
	public static void closeConnection(Connection pCon){
		getInstance().instCloseConnection(pCon);
		pCon=null;
	}

	public static void reconfigure(){
		getInstance().instReconfigure();
	}
	
}