package org.bits.ec.entity;

import org.bits.ec.dbcon.DBQuery;

/**
 * Roles Model
 */
public class RoleModel {

	/**
	 * Allowed Status for Role
	 */
	private int isAllowed(int pRoleID) {
		int mFlag = 0;
		Object mObj = null;
		mObj = new DBQuery().fetchKeyEntity(new Integer(pRoleID), "roleid",
				"allow", "role_table");
		if (mObj == null || !(mObj instanceof String))
			return mFlag;
		if ("Y".equals((String) mObj))
			mFlag = 1;
		return mFlag;
	}

	/**
	 * Validates Role
	 */
	public int validateRole(int pRoleID) {
		return isAllowed(pRoleID);
	}

	/**
	 * Role Name for Role ID
	 */
	public String getNameForID(int pRoleID) {
		Object mObj = null;
		mObj = new DBQuery().fetchKeyEntity(new Integer(pRoleID), "roleid",
				"rolename", "role_table");
		if (mObj == null || !(mObj instanceof String))
			return "";
		return (String) mObj;
	}

	/**
	 * Place ID for Role ID
	 */
	public int getPlaceIDForID(int pRoleID) {
		int mPlaceID = -1;
		Object mObj = null;
		mObj = new DBQuery().fetchKeyEntity(new Integer(pRoleID), "roleid",
				"placeid", "role_table");
		if (mObj == null || !(mObj instanceof Integer))
			return mPlaceID;
		mPlaceID = ((Integer) mObj).intValue();
		if (new PlaceModel().validatePlace(mPlaceID) <= 0)
			mPlaceID = -1;
		return mPlaceID;
	}

}