package org.bits.ec.protsys;

/**
 * The One Way Hasher
 */
public class TextHash {

	/**
	 * Keys used to Hash .
	 */
	private static String vPrintStr = "abcdefghijklmnopqrstuvwxyzZYXWVUTSRQPONMLKJIHGFEDCBA0123456789";

	private static String mDefKeyStr = "To Hell with Democracy";

	private String mKeyStr = "";

	/**
	 * To Set Default Key .
	 */
	public void setDefaultKey(String pDefKeyStr) {
		if (pDefKeyStr != null && !"".equals(pDefKeyStr))
			mDefKeyStr = pDefKeyStr;
	}

	/**
	 * To Set Key .
	 */
	public void setKey(String pKeyStr) {
		if (pKeyStr != null && !"".equals(pKeyStr))
			mKeyStr = pKeyStr;
		else
			mKeyStr = mDefKeyStr;
	}

	/**
	 * Default Constructor .
	 */
	public TextHash() {
		setKey(null);
	}

	/**
	 * 1 Arg Constructor .
	 */
	public TextHash(String pKeyStr) {
		setKey(pKeyStr);
	}

	/**
	 * One Way Hash Function .
	 */
	public String oneWayHash(String pName, String pSessionKey, String pPassword) {
		int mIter, mMaxLength;
		int mPrtStrLength = vPrintStr.length(), mKeyLength = mKeyStr.length();
		int mNameLength = 0, pSessionKeyLength = 0, mPasswordLength = 0;

		char mCharPrt, mCharKey, mCharName, mCharSessionKey, mCharPassword;
		StringBuffer mHashb = new StringBuffer();

		if (pName == null)
			pName = "";
		mNameLength = pName.length();
		if (pSessionKey == null)
			pSessionKey = "";
		pSessionKeyLength = pSessionKey.length();
		if (pPassword == null)
			pPassword = "";
		mPasswordLength = pPassword.length();

		// Determine Maximum length
		mMaxLength = (mKeyLength > mNameLength) ? mKeyLength : mNameLength;
		mMaxLength = (mMaxLength > pSessionKeyLength) ? mMaxLength
				: pSessionKeyLength;
		mMaxLength = (mMaxLength > mPasswordLength) ? mMaxLength
				: mPasswordLength;

		// Perform Loop .
		mCharPrt = 0;
		for (mIter = 0; mIter < mMaxLength; mIter++) {
			mCharKey = 0;
			if (mKeyLength > 0)
				mCharKey = mKeyStr.charAt(mIter % mKeyLength);

			mCharName = 0;
			if (mNameLength > 0)
				mCharName = pName.charAt(mIter % mNameLength);

			mCharSessionKey = 0;
			if (pSessionKeyLength > 0)
				mCharSessionKey = pSessionKey.charAt(mIter % pSessionKeyLength);

			mCharPassword = 0;
			if (mPasswordLength > 0)
				mCharPassword = pPassword.charAt(mIter % mPasswordLength);

			mCharPrt = vPrintStr.charAt((mCharPrt ^ mCharName ^ mCharSessionKey
					^ mCharPassword ^ mCharKey)
					% mPrtStrLength);
			mHashb.append(mCharPrt);
		}
		return mHashb.toString();
	}
}
