use ec;

drop table if exists vote_table;

drop table if exists ip_acl_table;

drop table if exists user_allowed_table;

drop table if exists user_table;

drop table if exists candidate_table;

drop table if exists role_table;

drop table if exists place_table;

create table place_table(placeid integer primary key auto_increment, placename varchar(48) unique not null);

create table role_table(roleid integer not null auto_increment unique, rolename varchar(64) not null, placeid integer not null, allow varchar(1) not null default 'Y', primary key (roleid, rolename, placeid), foreign key(placeid) references place_table(placeid));

create table candidate_table(candidateid integer not null auto_increment, roleid integer not null, candidatename varchar(128) not null, allow varchar(1) not null default 'Y', primary key(candidateid, roleid), foreign key(roleid) references role_table(roleid));

create table user_table(userid integer primary key auto_increment, username varchar(32) unique not null, userpassword varchar(256) not null, allow varchar(1) not null default 'Y');

create table user_allowed_table(userid integer not null, roleid integer not null, primary key(userid,roleid), foreign key(userid) references user_table(userid), foreign key(roleid) references role_table(roleid));

create table ip_acl_table(ipaddress varchar(32) primary key);

create table vote_table(candidateid integer not null,userid integer not null,tov date not null, ipaddress varchar(32) not null, primary key(candidateid,userid), foreign key(candidateid) references candidate_table(candidateid), foreign key(userid) references user_table(userid), foreign key(ipaddress) references ip_acl_table(ipaddress));

insert into place_table(placeid,placename) values(1,'-');
insert into place_table(placename) values('Ashok');
insert into place_table(placename) values('Bhagirath');
insert into place_table(placename) values('Budh');
insert into place_table(placename) values('Gandhi');
insert into place_table(placename) values('Krishna');
insert into place_table(placename) values('Malviya (Extension)');
insert into place_table(placename) values('Malviya');
insert into place_table(placename) values('Meera (Blocks 5 & 9)');
insert into place_table(placename) values('Meera (Blocks 1, 2, 3, 4, 6, 7, 8 & Old Block)');
insert into place_table(placename) values('Ram');
insert into place_table(placename) values('Rana Pratap');
insert into place_table(placename) values('Shankar');
insert into place_table(placename) values('Viswakarma');
insert into place_table(placename) values('Vyas');
insert into place_table(placename) values('Day Scholars');
insert into place_table(placename) values('None');

insert into role_table(roleid,rolename,placeid) values (1,'-',1);
insert into role_table(rolename,placeid) values ('President',17);
insert into role_table(rolename,placeid) values ('General Secretary',17);
insert into role_table(rolename,placeid) values ('Hostel Representative',2);
insert into role_table(rolename,placeid) values ('Hostel Representative',3);
insert into role_table(rolename,placeid) values ('Hostel Representative',4);
insert into role_table(rolename,placeid) values ('Hostel Representative',5);
insert into role_table(rolename,placeid) values ('Hostel Representative',6);
insert into role_table(rolename,placeid) values ('Hostel Representative',7);
insert into role_table(rolename,placeid) values ('Hostel Representative',8);
insert into role_table(rolename,placeid) values ('Hostel Representative',9);
insert into role_table(rolename,placeid) values ('Hostel Representative',10);
insert into role_table(rolename,placeid) values ('Hostel Representative',11);
insert into role_table(rolename,placeid) values ('Hostel Representative',12);
insert into role_table(rolename,placeid) values ('Hostel Representative',13);
insert into role_table(rolename,placeid) values ('Hostel Representative',14);
insert into role_table(rolename,placeid) values ('Hostel Representative',15);
insert into role_table(rolename,placeid) values ('Representative',16);

insert into candidate_table(candidateid, roleid, candidatename, allow) values (1,1,'-','N');

insert into candidate_table(roleid, candidatename) values (2,'Hari Krishna Reddy');
insert into candidate_table(roleid, candidatename) values (2,'Hitesh Mathur');
insert into candidate_table(roleid, candidatename) values (2,'None');

insert into candidate_table(roleid, candidatename) values (3,'Prashant Arora');
insert into candidate_table(roleid, candidatename) values (3,'Kamath Arjun P.');
insert into candidate_table(roleid, candidatename) values (3,'None');

insert into candidate_table(roleid, candidatename) values (4,'Anurag Reddy Kalakonda');
insert into candidate_table(roleid, candidatename) values (4,'Saurabh Thakur');
insert into candidate_table(roleid, candidatename) values (4,'None');

insert into candidate_table(roleid, candidatename) values (5,'Vikas Mishra');
insert into candidate_table(roleid, candidatename) values (5,'None');

insert into candidate_table(roleid, candidatename) values (6,'Ankush Asthana');
insert into candidate_table(roleid, candidatename) values (6,'G. Rajeev');
insert into candidate_table(roleid, candidatename) values (6,'None');

insert into candidate_table(roleid, candidatename) values (7,'Ankur Dalal');
insert into candidate_table(roleid, candidatename) values (7,'V. M. Ravi Teja Jonnala');
insert into candidate_table(roleid, candidatename) values (7,'None');

insert into candidate_table(roleid, candidatename) values (8,'Nithesh Chandra Gupta M.');
insert into candidate_table(roleid, candidatename) values (8,'Dheerain Doda');
insert into candidate_table(roleid, candidatename) values (8,'None');

insert into candidate_table(roleid, candidatename) values (9,'Rambabu Bala');
insert into candidate_table(roleid, candidatename) values (9,'None');

insert into candidate_table(roleid, candidatename) values (10,'Venkata Gangadhar Rao Y');
insert into candidate_table(roleid, candidatename) values (10,'None');

insert into candidate_table(roleid, candidatename) values (11,'Manasa D.');
insert into candidate_table(roleid, candidatename) values (11,'None');

insert into candidate_table(roleid, candidatename) values (12,'Hima Parvataneni');
insert into candidate_table(roleid, candidatename) values (12,'Haritha Peyyeti');
insert into candidate_table(roleid, candidatename) values (12,'None');

insert into candidate_table(roleid, candidatename) values (13,'K. Raghu');
insert into candidate_table(roleid, candidatename) values (13,'None');

insert into candidate_table(roleid, candidatename) values (14,'Sandeep Kumar');
insert into candidate_table(roleid, candidatename) values (14,'None');

insert into candidate_table(roleid, candidatename) values (15,'Ankur Aggarwal');
insert into candidate_table(roleid, candidatename) values (15,'V. Deepak');
insert into candidate_table(roleid, candidatename) values (15,'Abhishek Kumar Singh');
insert into candidate_table(roleid, candidatename) values (15,'Saurabh Sarin');
insert into candidate_table(roleid, candidatename) values (15,'None');

insert into candidate_table(roleid, candidatename) values (16,'Aayush Deora');
insert into candidate_table(roleid, candidatename) values (16,'Prateek Singh');
insert into candidate_table(roleid, candidatename) values (16,'Patnaik Shanthi Kiran');
insert into candidate_table(roleid, candidatename) values (16,'None');

insert into candidate_table(roleid, candidatename) values (17,'Nitesh Kumar Singh');
insert into candidate_table(roleid, candidatename) values (17,'Boppudi Sivaram Pramod');
insert into candidate_table(roleid, candidatename) values (17,'None');

insert into candidate_table(roleid, candidatename) values (18,'Alok Bhatia');
insert into candidate_table(roleid, candidatename) values (18,'Anubhav Nagpal');
insert into candidate_table(roleid, candidatename) values (18,'Rajesh Kumar Karwasra');
insert into candidate_table(roleid, candidatename) values (18,'None');

insert into ip_acl_table values('127.0.0.1');
