package org.bits.ec.util.resultsannounce;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import org.bits.ec.dbcon.DBManager;
import org.bits.ec.entity.CandidateModel;
import org.bits.ec.entity.PlaceModel;
import org.bits.ec.entity.RoleModel;
import org.bits.ec.entity.VoteModel;

/**
 * Election Results Announcement.
 */
public class ResultsAnnouncer {

	/**
	 * Prints Results to Stream.
	 */
	public void printCount() {
		String mCmdStr = null;
		String mPlaceName = null;
		Connection mCon = null;
		Statement mStmt = null;
		ResultSet mRs = null;
		DBManager mDBM = null;
		int mCandidateID = -1;
		int mRoleID = -1;
		int mVotes=0;

		RoleModel mRM = new RoleModel();
		PlaceModel mPM = new PlaceModel();
		CandidateModel mCM = new CandidateModel();
		VoteModel mVM = new VoteModel();

		mDBM = new DBManager();
		mCon = mDBM.getConnection();
		if (mCon == null)
			return;

		mCmdStr = "select candidateid from candidate_table order by roleid";

		try {
			mStmt = mCon.createStatement();
			mRs = mStmt.executeQuery(mCmdStr);
			while (mRs.next()) {
				try {
					mCandidateID = (int) mRs.getFloat(1);
					if(mCM.validateCandidate(mCandidateID)<=0) ;
					else{
						mVotes=mVM.votesFor(mCandidateID);
						mRoleID=mCM.getRoleIDForID(mCandidateID);
						mPlaceName=mPM.getNameForID(mRM.getPlaceIDForID(mRoleID));
						if("".equals(mPlaceName)||"-".equals(mPlaceName)||"None".equalsIgnoreCase(mPlaceName))
							System.out.println(mCM.getNameForID(mCandidateID)+" - "+mRM.getNameForID(mRoleID)+" : "+mVotes);
						else
							System.out.println(mCM.getNameForID(mCandidateID)+" - "+mRM.getNameForID(mRoleID)+" ("+mPlaceName+") : "+mVotes);
					}
				} catch (Exception eE) {
					eE.printStackTrace();
				}
			}
		} catch (SQLException eSQLE) {
			eSQLE.printStackTrace();
		}

		// Clean Up
		if (mRs != null) {
			try {
				mRs.close();
			} catch (SQLException eSQLE) {
				eSQLE.printStackTrace();
			}
		}
		mRs = null;

		if (mStmt != null) {
			try {
				mStmt.close();
			} catch (SQLException eSQLE) {
				eSQLE.printStackTrace();
			}
		}
		mStmt = null;

		mDBM.closeConnection(mCon);
		mCon = null;

	}

	/**
	 * Main Program.
	 */
	public static void main(String args[]) {
		(new ResultsAnnouncer()).printCount();
	}

}