package org.bits.ec.util.schemacreate;

import org.bits.ec.dbcon.DBQuery;
import org.bits.ec.entity.RoleModel;
import org.bits.ec.entity.UserModel;

/**
 * Data Entry Helper.
 */
public class DataEntry {

	/**
	 * Add User
	 */
	private int addUser(String pName, String pPassword) {
		int mRows = 0;
		if (pName == null || "".equals(pName))
			return mRows;
		if (pPassword == null || "".equals(pPassword))
			return mRows;
		mRows = new DBQuery()
				.executeUpdateQuery("insert into user_table(username,userpassword) values(\'"
						+ pName + "\',password(\'" + pPassword + "\'))");
		return mRows;
	}

	/**
	 * Add User Role
	 */
	private int addUserRole(String pName, int pRoleID) {
		int mRows = 0;
		int mUserID = -1;
		UserModel pUM = new UserModel();
		if (pUM.validateUser(pName) <= 0)
			return mRows;
		if (new RoleModel().validateRole(pRoleID) <= 0)
			return mRows;
		mUserID = pUM.getIDForName(pName);
		if (mUserID <= 0)
			return mRows;
		// Already Allowed.
		if (pUM.isAllowedForRole(pName, pRoleID) <= 0)
			;
		else
			return mRows;
		mRows = new DBQuery()
				.executeUpdateQuery("insert into user_allowed_table(userid,roleid) values("
						+ mUserID + "," + pRoleID + ")");
		return mRows;
	}

	/**
	 * Specifies RoleID for a given Bhawan and Room No.
	 */
	private static int getRoleIDFor(String pBhawan, int pRoomNo) {
		if (pBhawan.equalsIgnoreCase("AK"))
			return 4;
		if (pBhawan.equalsIgnoreCase("BG"))
			return 5;
		if (pBhawan.equalsIgnoreCase("BD"))
			return 6;
		if (pBhawan.equalsIgnoreCase("GN"))
			return 7;
		if (pBhawan.equalsIgnoreCase("KR"))
			return 8;
		if (pBhawan.equalsIgnoreCase("ML")) {
			if ((pRoomNo >= 500 && pRoomNo < 800))
				return 9;
			else
				return 10;		
		}
		if (pBhawan.equalsIgnoreCase("MR")) {
			if ((pRoomNo >= 5000 && pRoomNo < 6000)
					|| (pRoomNo >= 9000 && pRoomNo < 10000))
				return 11;
			else
				return 12;
		}
		if (pBhawan.equalsIgnoreCase("RM"))
			return 13;
		if (pBhawan.equalsIgnoreCase("RP"))
			return 14;
		if (pBhawan.equalsIgnoreCase("SK"))
			return 15;
		if (pBhawan.equalsIgnoreCase("VK"))
			return 16;
		if (pBhawan.equalsIgnoreCase("VY"))
			return 17;
		if (pBhawan.equalsIgnoreCase("DS"))
			return 18;
		return -1;
	}

	/**
	 * Adds an User to the Database.
	 */
	public int addUserAndRoles(String pIDNo, String pPassword, String pBhawan,
			int pRoomNo) {
		int mFlag = 0;
		if (pIDNo == null || "".equals(pIDNo))
			return mFlag;
		if (pPassword == null || "".equals(pPassword))
			return mFlag;
		if (pBhawan == null || "".equals(pBhawan)) 
			return mFlag;
		if (pBhawan.equalsIgnoreCase("PS")) 
			return mFlag;
		if (pRoomNo < 0) 
			return mFlag;
		if (addUser(pIDNo, pPassword) <= 0)
			return mFlag;
		if (addUserRole(pIDNo, 2) <= 0)
			return mFlag;
		if (addUserRole(pIDNo, 3) <= 0)
			return mFlag;
		if (addUserRole(pIDNo, getRoleIDFor(pBhawan, pRoomNo)) <= 0) 
			return mFlag;
		mFlag = 1;
		return mFlag;
	}
}