package org.bits.ec.util.schemacreate;

/**
 * Password Generator.
 */
public class PasswordGenerator {
	/**
	 * List of Allowed Characters while Hashing
	 */
	private static String vAllowedStr = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";

	/**
	 * Generates a Password
	 */
	public String generatePassword(int pMinLength, int pMaxLength,
			String pAllowedStr) {
		int mLengthDifference = 0, mExtLength, mIter, mRandomIndex;
		StringBuffer mPasswordb = new StringBuffer();
		if (pMinLength <= 0 || pMaxLength <= 0 || pMaxLength < pMinLength)
			return mPasswordb.toString();
		if (pAllowedStr == null || pAllowedStr.length() <= 0)
			return mPasswordb.toString();
		for (mIter = 0; mIter < pMinLength; mIter++) {
			mRandomIndex = ((int) (Math.random() * 1234567))
					% pAllowedStr.length();
			mPasswordb.append(pAllowedStr.charAt(mRandomIndex));
		}
		mLengthDifference = pMaxLength - pMinLength;
		if (mLengthDifference > 0) {
			mExtLength = ((int) (Math.random() * 1234567)) % mLengthDifference;
			for (mIter = 0; mIter < mExtLength; mIter++) {
				mRandomIndex = ((int) (Math.random() * 1234567))
						% pAllowedStr.length();
				mPasswordb.append(pAllowedStr.charAt(mRandomIndex));
			}
		}
		return mPasswordb.toString();
	}

	/**
	 * Generates a Password
	 */
	public String generatePassword(int pMinLength, int pMaxLength) {
		return generatePassword(pMinLength, pMaxLength, vAllowedStr);
	}
}