package db.exec;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.sql.Connection;
import db.cw.ConnectionWrapper;
import db.query.QueryOutput;

public class QueryRunner {

	private static final String DEFINPUTFILE="query.txt";
	private static final String DEFOUTPUTFILE="output.txt";
	private static final String INPUTFILE="db.query.inputfile";
	private static final String OUTPUTFILE="db.query.outputfile";
	
	public static void main(String[] pArgs) {
		String mInputFile=null;
		String mOutputFile=null;
		
		File mIFile=null;
		File mOFile=null;		
		
		BufferedReader mIBR=null;
		BufferedWriter mOBW=null;
		
		String mSQLQuery=null;
		String mTemp=null;
		
		Connection mCon=null;
		
		QueryOutput mQO=new QueryOutput();
		
		if(pArgs.length>0) {
			mInputFile=pArgs[0];
			if(pArgs.length>1) {
				mOutputFile=pArgs[1]; 
			}
		} 
		
		if(mInputFile==null) mInputFile=System.getProperty(INPUTFILE);  
		if(mOutputFile==null) mOutputFile=System.getProperty(OUTPUTFILE);
		
		if(mInputFile==null) mInputFile=DEFINPUTFILE;
		if(mOutputFile==null) mOutputFile=DEFOUTPUTFILE;
		
		if(mCon==null) {
			mCon=ConnectionWrapper.getConnection();			
		}

		if(mCon==null) {
			System.err.println("Can't connect to database.");
			return;
		}			
			
		System.out.println("Query File: "+mInputFile);
		System.out.println("Query Output File: "+mOutputFile);
		
		mIFile=new File(mInputFile);
		try{
			mIBR=new BufferedReader(new FileReader(mIFile));
		} catch(FileNotFoundException eFNFE){			
			eFNFE.printStackTrace();
			return;	
		}
		
		mOFile=new File(mOutputFile);
		try{
			mOBW=new BufferedWriter(new FileWriter(mOFile));
		} catch(IOException eIOE){
			eIOE.printStackTrace();
			try{
				mIBR.close();
			} catch(IOException eIOE2){
				eIOE2.printStackTrace();
			}
			return;	
		}	
				
		try{
		while((mTemp=mIBR.readLine())!=null){			  
			
			mSQLQuery=mTemp.trim();
			if(mSQLQuery!=null&&!("".equals(mSQLQuery))&&!mSQLQuery.startsWith("#")&&!mSQLQuery.startsWith("//")) {
				System.out.println();
				System.out.println("Executing Command: "+mSQLQuery);
				mQO.executeQuery(mCon,mSQLQuery,mOBW);	
				mOBW.newLine();
				System.out.println("DONE");				
			}
		}
		} catch(IOException eIOE){
			eIOE.printStackTrace(); 
		}

		ConnectionWrapper.closeConnection(mCon);
		mCon=null;
		
		try{
			mIBR.close();
			mIBR=null;
			mOBW.close();
			mOBW=null;
		} catch(IOException eIOE){
			eIOE.printStackTrace();
		}	
		
	}

}